#include <iostream>
#include <cmath>
using namespace std;
class Circle {
        private:
        double x;
        double y;
        double r;
        public:
		/*  */
        Circle() {
                cout << "Vvedite koordinati: ";
                cin >> x >> y;
                cout << "Vvedite radius: ";
                double tempr;
                cin >> tempr;
                if(tempr>=0) {
                        r = tempr;
                } else {
                        r = 0;
                }
        }
		/*   */
        Circle(double x, double y, double r=1) {
                this->x = x;
                this->y = y;
                if(r>=0) {
                        this->r = r;
                } else {
                        this->r = 0;
                }
        }
		/*,   */
        double square() {
                return M_PI*pow(r,2);
        }
		/*,     */
        double distanse(Circle& c) {
                return sqrt(abs(pow(x-c.x,2)+pow(y-c.y,2)));
        }
		/*, ,   */
        bool hitTestCircles(Circle& crc) {
                if(distanse(crc)==(double)(r+crc.r)||distanse(crc)==(double)(r-crc.r)) {
                        if(x!=crc.x||y!=crc.y||r!=crc.r) {
                                return true;
                        } else {
                                return false;
                        }
                } else {
                        return false;
                }

        }
		/*, ,      */
        bool inCircle(Circle& crc) {
                if(distanse(crc)<=(double)(crc.r-r)&&crc.r>r) {
                        return true;
                }
                return false;
        }
		/*,   */
        void changeR(double nRad) {
                if(nRad>0) {
                        r = nRad;
                }
        }
		/*,   */
        void changeKoords(double x=0, double y=0) {
                this->x = x;
                this->y = y;
        }
		/*  */
		Circle& operator = (Circle& crc) {
			if(&crc == this) return *this;
			x = crc.x;
			y = crc.y;
			r = crc.r;
			return *this;
		}
		/*   */
		bool operator == (Circle& crc) {
			return r==crc.r?true:false;
		}
		/*    */
		bool operator != (Circle& crc) {
			return !(*this == crc);
		}
		/*,   */
		double getRad() {
			return r;
		}
		/*,       (OX)*/
		double getX() {
			return x;
		}
		/*,       (OY)*/
		double getY() {
			return y;
		}
		/*,      */
        void printCircle() {
                cout << "Okrujnost s koordinatami (" << x << "; " << y << ")" << " i radiusom "<<r<<endl;
        }
};
int main(void) {
		/*   Circle*/
        Circle a(1,0,1);
        Circle b(0,0,2);
		/*     */
        a.printCircle();
		b.printCircle();
		/*,   */
		bool c = a!=b;
		cout << "!=?" << boolalpha << c << endl;
        //a.changeKoords();
		/*    Circle*/
        cout << "Square: " << a.square() << endl;
        cout << "Distanse: " << a.distanse(b) << endl;
        cout << "hitTest: " << boolalpha << a.hitTestCircles(b) << endl;
		cout << "Distanse: " << a.distanse(b) << endl;
		cout << "Sum of Rad: " << a.getRad()+b.getRad() << endl;
        cout << "In Circle b? " << boolalpha << a.inCircle(b) << endl;
        return 0;
}
