#include <iostream>
#include <cmath>
#include <stdio.h>
#include <stdlib.h>
using namespace std;
class Fraction {
	private:
	int numerator;
	int denominator;
	//int integer;
	/*NOD*/
	static int NOD(int x, int y) {
		int a = abs(x);
		int b = abs(y);
		int r = a%b;
		int rTemp = b;
		while(r!=0) {
			a = b;
			b = r;
			r = a%r;
			rTemp = b;
		}
		return rTemp;
	}
	/*NOK*/
	static int NOK(int a, int b) {
		return a*b/NOD(a,b);
	}
	
	public:
	/*,  */
	void reduce() {
		int nod = NOD(denominator,numerator);
		numerator/=nod;
		denominator/=nod;
	}
	/*  */
	Fraction() {
		/*   */
		int n=1, den=1;
		cout << "Enter fraction: ";
		cin >> n >> den;
		numerator = n;
		/*     */
		if(den!=0) {
			denominator = den;
			reduce();
		} else {
			denominator = 1;
		}
	}
	/* */
	Fraction(int x, int y) {
		numerator = x;
		if(y!=0) {
			denominator = y;
			reduce();
		} else {
			denominator = 1;
		}
	}
	/* */
	Fraction& operator = (Fraction& f) {
		if(&f == this) return *this;
		numerator = f.numerator;
		denominator = f.denominator;
		return *this;
	}
	/*,  */
	int getNumerator() {
		return numerator;
	}
	/*,  */
	int getDenominator() {
		return denominator;
	}
	/*,  */
	void setNumerator(int num) {
		numerator = num;
	}
	void setDenominator(int den) {
		denominator = den;
	}
	/*,  */
	void reverse() {
		int temp = numerator;
		numerator = denominator;
		denominator = temp;
	}
	/* */
	Fraction& operator + (Fraction& f) {
		Fraction *temp = new Fraction(1,1);
		temp->denominator = denominator*f.denominator;
		temp->numerator = numerator*f.denominator+f.numerator*denominator;
		temp->reduce();
		return *temp;
	}
	/* */
	Fraction& operator - (Fraction& f) {
		Fraction *temp = new Fraction(1,1);
		temp->denominator = denominator*f.denominator;
		temp->numerator = numerator*f.denominator-f.numerator*denominator;
		temp->reduce();
		return *temp;
	}
	/* */
	Fraction& operator * (Fraction& f) {
		Fraction *temp = new Fraction(1,1);
		temp->numerator = numerator*f.numerator;
		temp->denominator = denominator*f.denominator;
		temp->reduce();
		return *temp;
	}
	/* */
	Fraction& operator / (Fraction& f) {
		Fraction *temp = new Fraction(1,1);
		temp->denominator = denominator*f.numerator;
		temp->numerator = numerator*f.denominator;
		temp->reduce();
		return *temp;
	}
	/*     */
	double toDouble() {
		return (double)numerator/(double)denominator;
	}
	/*     */
	int toInt() {
		return numerator/denominator;
	}
	/*. printFraction - ,     */
	void printF() {
		if(denominator!=1) {
			cout << numerator << "/" << denominator << endl;
		} else {
			cout << numerator << endl;
		}
	}
};
int main() {
	/*   Fractions*/
	Fraction f(10, 5);
	Fraction s(25, 10);
	/*     =*/
	Fraction z = f*s;
	/*   */
	z.printF();
	/* */
	z.reverse();
	/*   */
	z.printF();
	return 0;
}
